        ;LIST   P=16f627                 ; Choose PIC
        Include "P16f818.inc"
;
;********************************************************************** 
        __config        _LVP_OFF & _CP_OFF & _BODEN_ON & _MCLR_OFF & _PWRTE_ON & _WDT_OFF & _EXTCLK & _DEBUG_OFF & _WRT_ENABLE_OFF & _CPD_OFF & _CCP1_RB3
                
			     
;-------------------------------------------
;       Port pin usage        
;-------------------------------------------
                                           
 ; Port A                                       Pin No.
        #define Bat_Detect      PORTA,0         ;17
        ;#define Unused         PORTA,1         ;18
        #define Rs              PORTA,2         ;1
        #define Disp_En         PORTA,3         ;2
        ;#define Unused         PORTA,4         ;3
        ;#define                PORTA,5         ;4
        ;#define                PORTA,6         ;15
        ;#define Osc_In         PORTA,7         ;16

 ; Port B       
        #define R_w             PORTB,0         ;6
        ;#define                PORTB,1         ;7
        #define LCD_Bit6        PORTB,2         ;8
        ;#define PWM_Out        PORTB,3         ;9
        ;#define Disp_4         PORTB,4         ;10
        ;#define Disp_5         PORTB,5         ;11
        ;#define VFO_In         PORTB,6         ;12
        ;#define Disp_7         PORTB,7         ;13

; Ports RB0 - RB3 = pins 6 - 9

        #define rp0             STATUS,RP0
 
;-------------------------------------------
;       Constant Equates Table        
;-------------------------------------------
TimerValue      equ     .256-.97        ; Timer reload value, approx 10mS
HoldDelay       equ     .225            ; Delay after, frequency change - Approx 8 seconds
ADPoleDelay     equ     .12             ; Approx 0.5 seconds
FCountDelay     equ     .5              ; Delay between frequency displays
MaxError        equ     .6              ; Max frequency error 
Tmr0PSCount     equ     .4              ; Used by 40ms counter
PadValue        equ     .202
					
Func_set        equ     b'00101000'
Display_off     equ     b'00001000'
Display_on      equ     b'00001100'     ;cursor off (bit 2)
Clr_display     equ     b'00000001'
Shift_Left	equ	b'00010000'
Entry_inc       equ     b'00000110'
Dd_ram_addr     equ     b'10000000'
Line_One	equ	b'10000000'
Line_Two	equ	b'11000000'

Lcd_init_delay  equ     .255

Portb_Out 	equ	b'01001111' 	;"and" with TRISB register
Portb_In	equ	b'10110000'	;"or" with TRISB register

Lcd_Port	equ     TRISB     
Lcd_Data        equ     PORTB

;-------------------------------------------
;       File Equates Table        
;-------------------------------------------
        cblock 0X20
        FreqLow
        FreqHigh
        FreqUpper
        LastFreqLow
        LastFreqHigh
        LastFreqUpper
        TMR1U
        ErrorLow
        ErrorHigh
        ErrorUpper
        HoldCounter
        StartupCounter
        FCount
        Tmr0PostScale
        Flags
        PWMLow
        PWMHigh
        Temp
        Temp1
        Temp2
        R0		
        R1		
        R2
        R3
        ACC_a_0
        ACC_a_1
        ACC_b_0 		
        ACC_b_1
        ACC_b_2
        ACC_c_0
        ACC_c_1
        ACC_c_2
        ACC_d_0
        ACC_d_1
        ACC_d_2
        Buffer_0	
        Buffer_1	
        Buffer_2	
        Buffer_3	
        Buffer_4	
        Buffer_5	
        Buffer_6	
        Buffer_7	
        Char
        Lsd
        Msd
        PadCount
        Init_Disp_Delay
        Text_pointer
        LoopCount
        LastBar
        ADPoleCount
        LastAD

        endc

;-------------------------------------------
;       File BIT Equates Table        
;-------------------------------------------
        #define ZeroFlag        Flags,0
        #define mult_carry      Flags,1

;-------------------------------------------
;       Main code        
;-------------------------------------------
ResetVector
        org     0       
        goto    Initialise

InteruptVector
        org     .4
        bcf     INTCON,GIE      ; Disable further interupts
        goto    TimerService
        ; If not called by timer 0 abort

InteruptEnd
        bsf     INTCON,GIE      ; Re-enable interupts
        retfie

;******************************************************************************
;	Text to be output to LCD module
;******************************************************************************
TextTable				;begining of text tables							
	movwf   PCL          		;jump to Char pointed to 
 
Text_Welcome_1
	dt	"MKARS80  V1.1   ",0
Text_Welcome_2
	dt	"www.mkars.org.uk",0
Text_MHz
	dt	" MHz",0
Text_LSB
	dt	"LSB ",0
Text_Bat
	dt	"Bat ",0
		
TextTableEnd
	if HIGH TextTable != HIGH TextTableEnd 
	error "Text Table breaks page boundary"
	endif
	;
;******************************************************************************
;	cg ram table - data loaded into user ram in LCD module
;	at program startup for "S" meter bars
;******************************************************************************
cg_ram_table
	addwf   PCL,f          	;jump to Char pointed to in w reg
	retlw	b'10000000'	;cg ram chacter no.1
	retlw	b'10000000'
	retlw	b'10011111'
	retlw	b'10011111'
	retlw	b'10011111'
	retlw	b'10000000'
	retlw	b'10000000'
	retlw	b'10000000'
	retlw	0		;stop here!
cg_ram_tableEnd
	if HIGH cg_ram_table != HIGH cg_ram_tableEnd 
	error "cg_ram_table breaks page boundary"
	endif
	;
;******************************************************************************
;	Write cg ram - routine to write data to user cg ram in LCD module
;******************************************************************************
write_cg_ram
	movlw	b'01000000'		; Write character no.0
	call	send_cmd
	movlw	00			; Address of first byte
write_cg_ram_loop
	movwf	Temp1
	call	cg_ram_table
	andlw   0ffh            	; Check if at end of data (zero
	btfsc   STATUS ,Z       	;  returned at end, all other data must
	goto    write_cg_ram_end  	;  be >0)           
	call    send_char       	; Store cg data
	movf    Temp1,w         	; Point to next data
	addlw   .1
	goto    write_cg_ram_loop
write_cg_ram_end
	return
	;	
;*****************************************************************************
Initialise
        ; Wait a while for the PSU to stabilise
        clrf    PORTA
        clrf    PORTB
        bsf     STATUS,RP0
        movlw   b'11110011'
        movwf   TRISA           ; Set up port A
        movlw   b'01000010'
        movwf   TRISB           ; Set up port B
        movlw   b'10000111'     ; Set up timer 0
        movwf   OPTION_REG      ; Internal clock, prescaler assigned to timer 0
                                ; and prescaler set to 256
        movlw   0XFF            ; Setup timer 2 for PWM
        movwf   PR2
        bsf     PIE1,TMR1IE     ; Enable timer 1 interupt
        movlw   b'11001110'     ; Select A/D convertor input as RA0, A/D clock/2 and result right justified
        movwf   ADCON1
        bcf     STATUS,RP0
        movlw   b'00000111'
        movwf   T1CON           ; Set up timer 1 
        movlw   b'00000100'
        movwf   T2CON
        call    InitialisePWM
        movlw   .30             ; FCountDelay     ; Set Freq counter delay period
        movwf   FCount
        movlw   .255
        movwf   LastBar         ; Preset LastBar to generate bar display
        movlw   ADPoleDelay
        movwf   ADPoleCount     ; Preset AD convertor delay counter
        ; Initialise A/D convertor module
        movlw   b'01000001'     ; Channel 0, A/D convertor running
        movwf   ADCON0	
        ; initialise display
        call    lcd_delay               ; Allow plenty of time for LCD to initialise
	call	Lcd_init		; Initialise LCD display
	;call 	write_cg_ram		; Write bar to CG ram
	movlw	Display_on		; Turn display on
	call	send_cmd
        call    Welcome_Routine
        ; Make 1st A/D conversion
        bsf     ADCON0,2
        movlw   .255 ;Tmr0PSCount     ; Load 40ms counter
        movwf   Tmr0PostScale
        ; Enable timer 1 interupt
        bsf     INTCON,TMR0IE     ; Enable timer 0 interupt
        bsf     INTCON,GIE      ; Enable interupts

;*****************************************************************************
Loop    
        goto    Loop            ; Loop until timer 0 overflows

;*****************************************************************************
InitialisePWM
        movlw   b'00001100'
        movwf   CCP1CON         ; Turn on PWM with xxxx11xx, lower PWM bits in 5-4
        clrf    PWMLow          ; Reset software PWM counter
        movlw   b'00000010'
        movwf   PWMHigh
        call    LoadPWM
        movlw   HoldDelay    ; Set start up delay 
        movwf   HoldCounter
        return

;******************************************************************************
Welcome_Routine
	movlw	.4
	movwf	Init_Disp_Delay	                ; Initialise startup display delay
	movlw	Clr_display
	call	send_cmd
	movlw   b'10000000'			; Sets ram address at 00h i.E. the start
	call    send_cmd
	movlw	Text_Welcome_1 - TextTable	; Point to message
	call	LCD_Out
	movlw   Line_Two			; First digit line 2
	call    send_cmd
	movlw	Text_Welcome_2 - TextTable	; Point to message
	call	LCD_Out
	return
	;
;*****************************************************************************
TimerService
        btfss   PIR1,TMR1IF     ; Check for timer 1 interupt
        goto    Timer0Service
        incf    TMR1U,f         ; Increment upper byte of frequency count
Timer0Service
        btfss   INTCON,TMR0IF     ; Check for timer 0 interupt
        goto    InteruptEnd
        decfsz  Tmr0PostScale,f
        goto    ReloadTimer0
        movlw   Tmr0PSCount     ; Load 40ms counter
        movwf   Tmr0PostScale
        movlw   PadValue
        movwf   PadCount
PadCounter
        decfsz  PadCount,f
        goto    PadCounter
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        nop
        bcf     T1CON,TMR1ON    ; Stop timer 1
        movf    HoldCounter,f   ; Is Start delay = 0?
        btfsc   STATUS,Z
        goto    DelayFinished   ; Yes, then continue
        decfsz  HoldCounter,f
        goto    WaitingTimeout  ; No, display frequency
        movfw   TMR1L           ; Save frequency count
        movwf   FreqLow
        movfw   TMR1H
        movwf   FreqHigh
        movfw   TMR1U
        movwf   FreqUpper
        call    DisplayFreq
;        call    DisplayBatStatus
        goto    ReloadTimer1    ; All setup so finish
WaitingTimeout
        decfsz  FCount,f
        goto    ReloadTimer1
        movlw   FCountDelay     ; Set Freq counter delay period
        movwf   FCount
        call    DisplayFreq
;        call    DisplayBatStatus
        goto    ReloadTimer1    ; No other action, exit
DelayFinished
        bsf     ZeroFlag
        movfw   TMR1L           ; Subtract to find error and save difference
        subwf   FreqLow,w
        movwf   ErrorLow
        btfss   STATUS,Z        ; Record value of zero bit
        bcf     ZeroFlag
        movfw   TMR1H           ; Subtract to find error and save difference
        btfss   STATUS,C
        addlw   .1              ; Add carry
        subwf   FreqHigh,w
        btfss   STATUS,Z        ; Record value of zero bit
        bcf     ZeroFlag
        movfw   TMR1U           ; Subtract to find error and save difference
        btfss   STATUS,C
        addlw   .1              ; Add carry
        subwf   FreqUpper,w
        btfss   STATUS,Z        ; Record value of zero bit
        bcf     ZeroFlag
        btfss   STATUS,C
        goto    FrequencyHigh   ; No carry so frequency is high
        btfsc   ZeroFlag        ; Test for ON frequency
        goto    ReloadTimer1    ; On frequency so no PWM adjustment needed
FrequencyLow
        movlw   MaxError        ; Test for error > max error
        subwf   ErrorLow,w
        btfsc   STATUS,C
        goto    ResetPWM        ; Error greater than allowed so reset PWM
        movlw   .1              ; Test for upper PWM limit
        addwf   PWMLow,w
        movfw   PWMHigh
        btfsc   STATUS,C        
        addlw   .1              ; Add carry to W if set
        addlw   b'11111100'
        btfsc   STATUS,C        ; PWM at maximum if carry set        
        goto    ReloadTimer1    ; At limit so abort        
        movlw   .1              ; Increment PWM
        addwf   PWMLow,f
        btfsc   STATUS,C        ; Add carry if set
        incf    PWMHigh,f
        call    LoadPWM
ReloadTimer1
        decfsz  ADPoleCount,f
        goto    ReloadTimer1_1
        movlw   ADPoleDelay
        movwf   ADPoleCount     ; Reload delay counter
        ; Read A/D convertor result 
        ; Load 9 bits od A/D result and multiply by 3662
        bcf     STATUS,C        
        rrf     ADRESH,w        ; Only 9 bits used
        movwf   ACC_a_1
        bsf     STATUS,RP0      ; Lose LSB
        rrf     ADRESL,w
        bcf     STATUS,RP0
        movwf   ACC_a_0
        subwf   LastAD,w        ; Check to see if same value as last time
        btfsc   STATUS,Z
        goto    ADPoleEnd       ; If same abandon display
        movfw   ACC_a_0
        movwf   LastAD
        movlw   .78
	movwf	ACC_b_0
        movlw   .14
        movwf   ACC_b_1
        ;
        call    D_mpy 
        ; Convert high to BCD
        movfw   ACC_b_0         ; High byte
        movwf   ACC_b_2
        movfw   ACC_c_0
        movwf   ACC_b_0
        movfw   ACC_c_1
        movwf   ACC_b_1
        call	B2_BCD	
	call	Expand_BCD
	;
        ; Display in row 2 digits 0 to 2
	; Set to line one, first character in
	movlw	b'11000000'
	call	send_cmd
	;
	movlw	Text_Bat - TextTable	        ; Point to message
	call	LCD_Out
        ;
	movfw	Buffer_0
	call	send_char	
	movfw	Buffer_1
	call	send_char	
	movlw	"."	
	call	send_char	; Display "."
	movfw	Buffer_2
	call	send_char	
	movlw	"V"	
	call	send_char	; Display "V"
        ; Start next A/D conversion
ADPoleEnd
        bsf     ADCON0,2
ReloadTimer1_1
        call    TuningBar
        clrf    TMR1L          
        clrf    TMR1H           
        clrf    TMR1U           ; Reload TMR1L, TIMR1H and pseudo timer TMR1U with 0
        bcf     PIR1,TMR1IF
ReloadTimer0
        movlw   TimerValue
        movwf   TMR0            ; Reload timer
        bcf     INTCON,TMR0IF    ; Clear interupt flag
        bsf     T1CON,TMR1ON    ; Enable counter(timer 1) 
        goto    InteruptEnd

FrequencyHigh
        movlw   MaxError+.1     ; Test for error > max error
        addwf   ErrorLow,w
        btfss   STATUS,C
        goto    ResetPWM        ; Error greater than allowed so reset PWM
        movf    PWMLow,f
        btfss   STATUS,Z        ; Test for lower PWM limit
        goto    DecrementPWM    ; Not at zero so continue
        movf    PWMHigh,f
        btfsc   STATUS,Z        
        goto    ReloadTimer1    ; PWM at lower limit
DecrementPWM
        movlw   .1
        subwf   PWMLow,f
        btfss   STATUS,C
        decf    PWMHigh,f       ; Decrement PWMHigh if carry clear
        call    LoadPWM
        goto    ReloadTimer1

;*****************************************************************************
LoadPWM
        movfw   PWMHigh         ; Save PWM files to temporary registers
        movwf   Temp1
        movfw   PWMLow
        movwf   Temp2
        rrf     Temp1,f         ; Rotate high byte in to low and set
        rrf     Temp2,f         ;  CCP1CON bits with "overflow"
        bcf     CCP1CON,4
        btfsc   STATUS,C
        bsf     CCP1CON,4
        rrf     Temp1,f
        rrf     Temp2,w
        bcf     CCP1CON,5
        btfsc   STATUS,C
        bsf     CCP1CON,5
        movwf   CCPR1L          ; Save shifted high byte in PWM register
        return

ResetPWM
        call    InitialisePWM
        goto    ReloadTimer1

;*****************************************************************************
LCD_Out 
LCD_Out_loop
	movwf	Text_pointer
	movwf   Temp1           	;Temp1 holds start of message 
	movlw	LOW TextTable	        ;address
	addwf	Temp1,f		        ;add offset
	movlw	HIGH TextTable	
	btfsc	STATUS,C		;check if over page boundary
	addlw	1			;yes so inc high byte
	movwf	PCLATH
	movfw	Temp1
	call	TextTable
	andlw   0ffh   			;check if at end of message (zero
	btfsc   STATUS,Z	  	;returned at end)
	goto    LCD_Out_end         
	call    send_char		;display character
	movfw   Text_pointer		;point to next character
	addlw   1
	goto    LCD_Out_loop
LCD_Out_end
	return

;*****************************************************************************
DisplayFreq
	;	Set to line one, first character in
	movlw	b'10000000'
	call	send_cmd
	;
	movlw	Text_LSB - TextTable	        ; Point to message
	call	LCD_Out
        ;
        movlw   h'90'
        movwf   Temp
	movfw	TMR1L
        subwf   Temp,w
	movwf	ACC_b_0
        ;
        movlw   h'1a'
        movwf   Temp
        movfw   TMR1H
        btfss   STATUS,C   
        addlw   .1     
	subwf	Temp,w
	movwf	ACC_b_1
        ;
        movlw   h'06'
        movwf   Temp
        movfw   TMR1U
        btfss   STATUS,C   
        addlw   .1     
        subwf	Temp,w
	movwf	ACC_b_2		;  
	;
        call    Mult25
        call	B2_BCD	
	call	Expand_BCD
	;
	movfw	Buffer_0
	call	send_char	; 1MHz
	movlw	"."	
	call	send_char	; Display "."
	movfw	Buffer_1
	call	send_char	; 100kHz
	movfw	Buffer_2
	call	send_char	; 10kHz
	movfw	Buffer_3
	call	send_char	; 1KHz
	movfw	Buffer_4
	call	send_char	; 100Hz
	movfw	Buffer_5
	call	send_char	; 10Hz
	movfw	Buffer_6
	call	send_char	; 1Hz
	;
	movlw	Text_MHz - TextTable
	call	LCD_Out
	return

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
TuningBar
        comf    CCPR1L,w
        andlw   b'11100000'     ; Remove bits 0-4
        movwf   Buffer_0            ; Save 
        swapf   Buffer_0,f          ; Swap nibbles
        bcf     STATUS,C
        rrf     Buffer_0,f      ; Allign bits
        subwf   LastBar,w
        btfsc   STATUS,Z        ; Same as last bar position?
        goto    TuningBarEnd    ; Z bit set so is the same
        movfw   Buffer_0
        movwf   LastBar         ; Save value for next pass
        incf    Buffer_0,f          ; Increment file
        movlw   .7
        movwf   LoopCount       ; Set up counter for 8 bits
	movlw	b'11001001'     ; Start at 9th character position on line two
	call	send_cmd
BarLoop
        movlw   "-"             ; Set to output a bar
        decfsz  Buffer_0,f
        movlw   " "             ; Otherwise output a "space"
        call    send_char
        decfsz  LoopCount,f
        goto    BarLoop         ; Loop until all 8 bits done
TuningBarEnd
        return

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;		Modified from AN526
;********************************************************************
;                  Binary To BCD Conversion Routine
;      This routine converts a 24 Bit binary Number to a 7 Digit
; BCD Number. 
;       The 24 bit binary number is input in locations ACC_b_2,ACC_b_1 and
; ACC_b_0 with the high byte in ACC_b_2.
;       The 7 digit BCD number is returned in R0, R1, R2 and R3 with R0
; containing the MSD in its right most nibble.
;
;
;       Program:          B16TOBCD.ASM 
;
;*******************************************************************;
;
B2_BCD  bcf     STATUS,0 	; clear the carry bit
	movlw   .24
	movwf   Temp2
	clrf    R0
	clrf    R1
	clrf    R2
	clrf	R3
loop24  
	rlf     ACC_b_0, F
	rlf     ACC_b_1, F
	rlf     ACC_b_2, F
	rlf     R3, F
	rlf     R2, F
	rlf     R1, F
	rlf     R0, F
;
	decfsz  Temp2, F
	goto    adjDEC
	RETLW   0
;
adjDEC  
	movlw   R3
	movwf   FSR
	call    adjBCD
;
	movlw   R2
	movwf   FSR
	call    adjBCD
;
	movlw   R1
	movwf   FSR
	call    adjBCD
;
	movlw   R0
	movwf   FSR
	call    adjBCD
;
	goto    loop24
;
adjBCD  movlw   3
	addwf   0,W
	movwf   Temp1
	btfsc   Temp1,3	; test if result > 7
	movwf   0
	movlw   30
	addwf   0,W
	movwf   Temp1
	btfsc   Temp1,7 	; test if result > 7
	movwf   0              	; save as MSD
	retlw   0

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Expand_BCD
	movfw	R0
	addlw	h'30'		; Add ascii offset
	movwf	Buffer_0
;
	swapf	R1,w
	andlw	h'0f'		; Mask off lower nibble
	addlw	h'30'
	movwf	Buffer_1
;
	movfw	R1
	andlw	h'0f'		; Mask off lower nibble	
	addlw	h'30'
	movwf	Buffer_2
;
	swapf	R2,w
	andlw	h'0f'		; Mask off lower nibble
	addlw	h'30'
	movwf	Buffer_3
;
	movfw	R2
	andlw	h'0f'		; Mask off lower nibble	
	addlw	h'30'
	movwf	Buffer_4
;
	swapf	R3,w
	andlw	h'0f'		; Mask off lower nibble
	addlw	h'30'
	movwf	Buffer_5
;
	movfw	R3
	andlw	h'0f'		; Mask off lower nibble	
	addlw	h'30'
	movwf	Buffer_6
	return

;*******************************************************************;
Mult25
        ; Shift left 3 times = x8
        bcf     STATUS,C
        rlf     ACC_b_0,w
        movwf   ACC_c_0
        rlf     ACC_b_1,w
        movwf   ACC_c_1
        rlf     ACC_b_2,w
        movwf   ACC_c_2         ; x2
        rlf     ACC_c_0,f
        rlf     ACC_c_1,f
        rlf     ACC_c_2,f       ; x4
        rlf     ACC_c_0,f
        rlf     ACC_c_1,f
        rlf     ACC_c_2,f       ; x8
        ; Save in ACC_d_X
        movfw   ACC_c_0
        movwf   ACC_d_0
        movfw   ACC_c_1
        movwf   ACC_d_1
        movfw   ACC_c_2
        movwf   ACC_d_2
        bcf     STATUS,C
        ; Shift left 4 times = x16
        rlf     ACC_c_0,f
        rlf     ACC_c_1,f
        rlf     ACC_c_2,f       ; x16
        ; Add x8 and x16 together = x24
        movfw   ACC_d_0
        addwf   ACC_c_0,f
        movfw   ACC_d_1
        btfsc   STATUS,C
        incfsz  ACC_d_1,w
        addwf   ACC_c_1,f
        movfw   ACC_d_2
        btfsc   STATUS,C
        incfsz  ACC_d_2,w
        addwf   ACC_c_2,f
        ; Add to original = x25
        movfw   ACC_c_0
        addwf   ACC_b_0,f
        movfw   ACC_c_1
        btfsc   STATUS,C
        incfsz  ACC_c_1,w
        addwf   ACC_b_1,f
        movfw   ACC_c_2
        btfsc   STATUS,C
        incfsz  ACC_c_2,w
        addwf   ACC_b_2,f
        return

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;		Modified from AN526
;*******************************************************************
;                    Double Precision Multiplication
;
;               ( Optimized for Code Size : Looped Code )
;
;*******************************************************************;
;   Multiplication : ACCb(16 bits) * ACCa(16 bits) -> ACCb,ACCc ( 32 bits )
;      (a) Load the 1st operand in location ACC_a_0 & ACC_a_1 ( 16 bits )
;      (b) Load the 2nd operand in location ACC_b_0 & ACC_b_1 ( 16 bits )
;      (c) CALL D_mpy
;      (d) The 32 bit result is in location ( ACC_b_1,ACC_b_0,ACC_c_1,ACC_c_0 )
;
;   Performance :
;               Program Memory  :       033
;               Clock Cycles    :       333
;
;       Note : The above timing is the worst case timing, when the
;               register ACCb = FFFF. The speed may be improved if
;               the register ACCb contains a number ( out of the two
;               numbers ) with less number of 1s.
;               The performance specs are for Unsigned arithmetic ( i.e,
;               with "SIGNED equ  FALSE ").
;
;               The performance specs are for Unsigned arithmetic ( i.e,
;               with "SIGNED equ  FALSE ").
;
;
;       Program:          DBL_MPYS.ASM 
;       Revision Date:   
;                         12-12-95      Compatibility with MPASMWIN 1.30
;
;*******************************************************************;
;         Double Precision Addition ( ACCb + ACCa -> ACCb )
;
D_add   bcf	mult_carry	;Clear Temp_1 Carry bit
	movf    ACC_a_0,w        ; Addition ( ACCb + ACCa -> ACCb )
	addwf   ACC_b_0, F       ;add lsb
	movlw	.1
	btfsc   STATUS,C		;add in carry
 	addwf	ACC_b_1, F
	btfsc	STATUS,C
	bsf	mult_carry	
	movf    ACC_a_1,w
	addwf   ACC_b_1, F         ;add msb
	btfsc	mult_carry
	bsf	STATUS,C
	retlw   0
;*******************************************************************
;               Double Precision Multiply ( 16x16 -> 32 )
;         ( ACCb*ACCa -> ACCb,ACCc ) : 32 bit output with high word
;  in ACCb ( ACC_b_1,ACC_b_0 ) and low word in ACCc ( ACC_c_1,ACC_c_0 ).
;
D_mpy                           ;results in ACCb(16 msb's) and ACCc(16 lsb's)
;
	call    setup
mloop   rrf     ACC_d_1, F       ;rotate d right
	rrf     ACC_d_0, F
	btfsc   STATUS,C    	;need to add?
	call    D_add
	rrf     ACC_b_1, F
	rrf     ACC_b_0, F
	rrf     ACC_c_1, F
	rrf     ACC_c_0, F
	decfsz  Temp1, F        ;loop until all bits checked
	goto    mloop
;
	retlw   0
;*******************************************************************
;
setup   movlw   .16             ; for 16 shifts
	movwf   Temp1
	movf    ACC_b_1,w          ;move ACCb to ACCd
	movwf   ACC_d_1
	movf    ACC_b_0,w
	movwf   ACC_d_0
	clrf    ACC_b_1
	clrf    ACC_b_0
	retlw   0
;
;*******************************************************************
;
neg_A   comf    ACC_a_0, F       ; negate ACCa ( -ACCa -> ACCa )
	incf    ACC_a_0, F
	btfsc   STATUS,Z
	decf    ACC_a_1, F
	comf    ACC_a_1, F
	retlw   0
;
        include "lcd_4bit.inc"

	END


